// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from soccer_vision_msgs:msg/Ball.idl
// generated code does not contain a copyright notice
#include "soccer_vision_msgs/msg/detail/ball__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"
// Member `center`
#include "geometry_msgs/msg/detail/point__functions.h"

bool
soccer_vision_msgs__msg__Ball__init(soccer_vision_msgs__msg__Ball * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    soccer_vision_msgs__msg__Ball__fini(msg);
    return false;
  }
  // center
  if (!geometry_msgs__msg__Point__init(&msg->center)) {
    soccer_vision_msgs__msg__Ball__fini(msg);
    return false;
  }
  return true;
}

void
soccer_vision_msgs__msg__Ball__fini(soccer_vision_msgs__msg__Ball * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // center
  geometry_msgs__msg__Point__fini(&msg->center);
}

soccer_vision_msgs__msg__Ball *
soccer_vision_msgs__msg__Ball__create()
{
  soccer_vision_msgs__msg__Ball * msg = (soccer_vision_msgs__msg__Ball *)malloc(sizeof(soccer_vision_msgs__msg__Ball));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(soccer_vision_msgs__msg__Ball));
  bool success = soccer_vision_msgs__msg__Ball__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
soccer_vision_msgs__msg__Ball__destroy(soccer_vision_msgs__msg__Ball * msg)
{
  if (msg) {
    soccer_vision_msgs__msg__Ball__fini(msg);
  }
  free(msg);
}


bool
soccer_vision_msgs__msg__Ball__Sequence__init(soccer_vision_msgs__msg__Ball__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  soccer_vision_msgs__msg__Ball * data = NULL;
  if (size) {
    data = (soccer_vision_msgs__msg__Ball *)calloc(size, sizeof(soccer_vision_msgs__msg__Ball));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = soccer_vision_msgs__msg__Ball__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        soccer_vision_msgs__msg__Ball__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
soccer_vision_msgs__msg__Ball__Sequence__fini(soccer_vision_msgs__msg__Ball__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      soccer_vision_msgs__msg__Ball__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

soccer_vision_msgs__msg__Ball__Sequence *
soccer_vision_msgs__msg__Ball__Sequence__create(size_t size)
{
  soccer_vision_msgs__msg__Ball__Sequence * array = (soccer_vision_msgs__msg__Ball__Sequence *)malloc(sizeof(soccer_vision_msgs__msg__Ball__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = soccer_vision_msgs__msg__Ball__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
soccer_vision_msgs__msg__Ball__Sequence__destroy(soccer_vision_msgs__msg__Ball__Sequence * array)
{
  if (array) {
    soccer_vision_msgs__msg__Ball__Sequence__fini(array);
  }
  free(array);
}
