// generated from rosidl_generator_c/resource/idl__functions.h.em
// with input from soccer_vision_msgs:msg/GoalpostArray.idl
// generated code does not contain a copyright notice

#ifndef SOCCER_VISION_MSGS__MSG__DETAIL__GOALPOST_ARRAY__FUNCTIONS_H_
#define SOCCER_VISION_MSGS__MSG__DETAIL__GOALPOST_ARRAY__FUNCTIONS_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stdlib.h>

#include "rosidl_runtime_c/visibility_control.h"
#include "soccer_vision_msgs/msg/rosidl_generator_c__visibility_control.h"

#include "soccer_vision_msgs/msg/detail/goalpost_array__struct.h"

/// Initialize msg/GoalpostArray message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * soccer_vision_msgs__msg__GoalpostArray
 * )) before or use
 * soccer_vision_msgs__msg__GoalpostArray__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_soccer_vision_msgs
bool
soccer_vision_msgs__msg__GoalpostArray__init(soccer_vision_msgs__msg__GoalpostArray * msg);

/// Finalize msg/GoalpostArray message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_soccer_vision_msgs
void
soccer_vision_msgs__msg__GoalpostArray__fini(soccer_vision_msgs__msg__GoalpostArray * msg);

/// Create msg/GoalpostArray message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * soccer_vision_msgs__msg__GoalpostArray__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_soccer_vision_msgs
soccer_vision_msgs__msg__GoalpostArray *
soccer_vision_msgs__msg__GoalpostArray__create();

/// Destroy msg/GoalpostArray message.
/**
 * It calls
 * soccer_vision_msgs__msg__GoalpostArray__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_soccer_vision_msgs
void
soccer_vision_msgs__msg__GoalpostArray__destroy(soccer_vision_msgs__msg__GoalpostArray * msg);


/// Initialize array of msg/GoalpostArray messages.
/**
 * It allocates the memory for the number of elements and calls
 * soccer_vision_msgs__msg__GoalpostArray__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_soccer_vision_msgs
bool
soccer_vision_msgs__msg__GoalpostArray__Sequence__init(soccer_vision_msgs__msg__GoalpostArray__Sequence * array, size_t size);

/// Finalize array of msg/GoalpostArray messages.
/**
 * It calls
 * soccer_vision_msgs__msg__GoalpostArray__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_soccer_vision_msgs
void
soccer_vision_msgs__msg__GoalpostArray__Sequence__fini(soccer_vision_msgs__msg__GoalpostArray__Sequence * array);

/// Create array of msg/GoalpostArray messages.
/**
 * It allocates the memory for the array and calls
 * soccer_vision_msgs__msg__GoalpostArray__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_soccer_vision_msgs
soccer_vision_msgs__msg__GoalpostArray__Sequence *
soccer_vision_msgs__msg__GoalpostArray__Sequence__create(size_t size);

/// Destroy array of msg/GoalpostArray messages.
/**
 * It calls
 * soccer_vision_msgs__msg__GoalpostArray__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_soccer_vision_msgs
void
soccer_vision_msgs__msg__GoalpostArray__Sequence__destroy(soccer_vision_msgs__msg__GoalpostArray__Sequence * array);

#ifdef __cplusplus
}
#endif

#endif  // SOCCER_VISION_MSGS__MSG__DETAIL__GOALPOST_ARRAY__FUNCTIONS_H_
